// CV (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i,dn;
	unsigned char id1[] = "- Issural -  Sys ";

	struct fpos md2[] =
	{
		{ 0x44, 0x01, 0x1500 },
		{ 0x46, 0x01, 0x1500 },
		{ 0x48, 0x01, 0x1500 },
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc < 2 || argc > 3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	if (argc==3)
	{
		dn = atoi(argv[2]);
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x13);
		disk.SetRecordRange(0x01,0x10);
		// ȃf[^̕ŃfBXN𔻒
		if (!memcmp(&buff[1], id1, sizeof(id1)-1) || dn==1)
		{
			printf("Disk 1 F܂.\n");
			// CvO
			fcut("DRIVER", 0x0d, 0x06, 0x01, 0x05, 0x01, 0x0000, 0x0c00);
			fcut("MUS00", 0x44, 0x22, 0x00, 0x01, 0x01, 0x0000, 0x1600);
		}
		else
		{
			printf("Disk 2Ƃăt@C؂o܂.\n");
			for (i=0; md2[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",i+1);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, 0x0000, md2[i].size);
			}
		}
	}
	return 0;
}

